module.exports = function(sequelize, DataTypes) {
  const Version = sequelize.define('Version', {
    version: DataTypes.STRING(64), // eslint-disable-line new-cap
    // name limit 191 - scope + version + file extension
    attachment: DataTypes.STRING(191), // eslint-disable-line new-cap
    url: DataTypes.STRING(512), // eslint-disable-line new-cap
    sha: DataTypes.STRING(40), // eslint-disable-line new-cap
    registry: DataTypes.STRING(64), // eslint-disable-line new-cap
    _raw: DataTypes.TEXT('MEDIUMTEXT'), // eslint-disable-line new-cap
  }, {
    indexes: [
      {
        fields: ['version'],
      },
      {
        fields: ['attachment'],
      },
    ],
    underscoredAll: true,
    charset: 'utf8mb4',
  });

  Version.associate = function(models) {
    Version.belongsTo(models.Package, {
      onDelete: 'CASCADE',
    });
  };

  return Version;
};
